%?mingw_package_header

# first two digits of version
%define release_version %(echo %{version} | awk -F. '{print $1"."$2}')

Name:		mingw-libsoup
Version:	2.43.90
Release:	1%{?dist}
Summary:	MinGW library for HTTP and XML-RPC functionality

License:	LGPLv2
Group:		Development/Libraries
URL:		http://live.gnome.org/LibSoup
Source0:	http://download.gnome.org/sources/libsoup/%{release_version}/libsoup-%{version}.tar.xz

BuildArch:	noarch

BuildRequires:	mingw32-filesystem >= 95
BuildRequires:	mingw32-gcc
BuildRequires:	mingw32-binutils
BuildRequires:	mingw32-glib2
BuildRequires:	mingw32-libxml2
BuildRequires:	mingw32-sqlite

BuildRequires:  mingw64-filesystem >= 95
BuildRequires:  mingw64-gcc
BuildRequires:  mingw64-binutils
BuildRequires:  mingw64-glib2
BuildRequires:  mingw64-libxml2
BuildRequires:  mingw64-sqlite

# For glib-genmarshal
BuildRequires:	glib2-devel
BuildRequires:	intltool


%description
Libsoup is an HTTP library implementation in C. It was originally part
of a SOAP (Simple Object Access Protocol) implementation called Soup, but
the SOAP and non-SOAP parts have now been split into separate packages.
 
libsoup uses the Glib main loop and is designed to work well with GTK
applications. This enables GNOME applications to access HTTP servers
on the network in a completely asynchronous fashion, very similar to
the Gtk+ programming model (a synchronous operation mode is also
supported for those who want it).

This is the MinGW build of Libsoup


# Win32
%package -n mingw32-libsoup
Summary:	MinGW library for HTTP and XML-RPC functionality
Requires:       pkgconfig

%description -n mingw32-libsoup
Libsoup is an HTTP library implementation in C. It was originally part
of a SOAP (Simple Object Access Protocol) implementation called Soup, but
the SOAP and non-SOAP parts have now been split into separate packages.

libsoup uses the Glib main loop and is designed to work well with GTK
applications. This enables GNOME applications to access HTTP servers
on the network in a completely asynchronous fashion, very similar to
the Gtk+ programming model (a synchronous operation mode is also
supported for those who want it).

This is the MinGW build of Libsoup

%package -n mingw32-libsoup-static
Summary:	Static version of the MinGW Windows Libsoup library
Requires:	mingw32-libsoup = %{version}-%{release}
Group:		Development/Libraries

%description -n mingw32-libsoup-static
Static version of the MinGW Windows Libsoup library.

# Win64
%package -n mingw64-libsoup
Summary:        MinGW library for HTTP and XML-RPC functionality
Requires:       pkgconfig

%description -n mingw64-libsoup
Libsoup is an HTTP library implementation in C. It was originally part
of a SOAP (Simple Object Access Protocol) implementation called Soup, but
the SOAP and non-SOAP parts have now been split into separate packages.

libsoup uses the Glib main loop and is designed to work well with GTK
applications. This enables GNOME applications to access HTTP servers
on the network in a completely asynchronous fashion, very similar to
the Gtk+ programming model (a synchronous operation mode is also
supported for those who want it).

This is the MinGW build of Libsoup

%package -n mingw64-libsoup-static
Summary:        Static version of the MinGW Windows Libsoup library
Requires:       mingw64-libsoup = %{version}-%{release}
Group:          Development/Libraries

%description -n mingw64-libsoup-static
Static version of the MinGW Windows Libsoup library.


%?mingw_debug_package


%prep
%setup -q -n libsoup-%{version}


%build
# Workaround for intltool bug #398571 which causes translations to go to
# %%{mingw32_libdir}/locale instead of %%{mingw32_datadir}/locale
export DATADIRNAME=share

# Libsoup can't build static and shared libraries in one go, so we build the package twice here
export CFLAGS="-DGLIB_STATIC_COMPILATION -DGOBJECT_STATIC_COMPILATION -DLIBXML_STATIC'"
MINGW_BUILDDIR_SUFFIX=static %mingw_configure --with-gnome --without-apache-httpd --enable-static --disable-shared
unset CFLAGS
MINGW_BUILDDIR_SUFFIX=shared %mingw_configure --with-gnome --without-apache-httpd --disable-static --enable-shared

MINGW_BUILDDIR_SUFFIX=static %mingw_make %{?_smp_mflags}
MINGW_BUILDDIR_SUFFIX=shared %mingw_make %{?_smp_mflags}


%install
# First install all the files belonging to the shared build
MINGW_BUILDDIR_SUFFIX=shared %mingw_make install DESTDIR=$RPM_BUILD_ROOT

# Install all the files from the static build in a seperate folder
# and move the static libraries to the right location
MINGW_BUILDDIR_SUFFIX=static %mingw_make install DESTDIR=$RPM_BUILD_ROOT/build_static
mv $RPM_BUILD_ROOT/build_static%{mingw32_libdir}/*.a $RPM_BUILD_ROOT%{mingw32_libdir}
mv $RPM_BUILD_ROOT/build_static%{mingw64_libdir}/*.a $RPM_BUILD_ROOT%{mingw64_libdir}

# Remove the .la files
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/*.la

# Drop the folder which was temporary used for installing the static bits
rm -rf $RPM_BUILD_ROOT/build_static

# Strip all the GTK-Doc
rm -rf $RPM_BUILD_ROOT%{mingw32_datadir}/gtk-doc
rm -rf $RPM_BUILD_ROOT%{mingw64_datadir}/gtk-doc

%mingw_find_lang libsoup


# Win32
%files -n mingw32-libsoup -f mingw32-libsoup.lang
%doc COPYING
%{mingw32_bindir}/libsoup-2.4-1.dll
%{mingw32_bindir}/libsoup-gnome-2.4-1.dll
%{mingw32_includedir}/libsoup-2.4
%{mingw32_includedir}/libsoup-gnome-2.4
%{mingw32_libdir}/libsoup-2.4.dll.a
%{mingw32_libdir}/libsoup-gnome-2.4.dll.a
%{mingw32_libdir}/pkgconfig/libsoup-2.4.pc
%{mingw32_libdir}/pkgconfig/libsoup-gnome-2.4.pc

%files -n mingw32-libsoup-static
%{mingw32_libdir}/libsoup-2.4.a
%{mingw32_libdir}/libsoup-gnome-2.4.a

# Win64
%files -n mingw64-libsoup -f mingw64-libsoup.lang
%doc COPYING
%{mingw64_bindir}/libsoup-2.4-1.dll
%{mingw64_bindir}/libsoup-gnome-2.4-1.dll
%{mingw64_includedir}/libsoup-2.4
%{mingw64_includedir}/libsoup-gnome-2.4
%{mingw64_libdir}/libsoup-2.4.dll.a
%{mingw64_libdir}/libsoup-gnome-2.4.dll.a
%{mingw64_libdir}/pkgconfig/libsoup-2.4.pc
%{mingw64_libdir}/pkgconfig/libsoup-gnome-2.4.pc

%files -n mingw64-libsoup-static
%{mingw64_libdir}/libsoup-2.4.a
%{mingw64_libdir}/libsoup-gnome-2.4.a


%changelog
* Sat Sep  7 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.43.90-1
- Update to 2.43.90

* Sat Aug  3 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.43.5-1
- Update to 2.43.5
- Make sure translations get installed to the correct folder (intltool bug #398571)

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.43.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Jul 13 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.43.4-1
- Update to 2.43.4

* Sun Jun 16 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.43.1-2
- Rebuild to resolve InterlockedCompareExchange regression in mingw32 libraries

* Thu May  9 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.43.1-1
- Update to 2.43.1

* Fri Mar 29 2013 Kalev Lember <kalevlember@gmail.com> - 2.42.0-1
- Update to 2.42.0

* Sun Mar 24 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.41.92-1
- Update to 2.41.92

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.40.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Nov 29 2012 Kalev Lember <kalevlember@gmail.com> - 2.40.2-1
- Update to 2.40.2

* Sat Oct 20 2012 Kalev Lember <kalevlember@gmail.com> - 2.40.1-1
- Update to 2.40.1

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.38.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Apr 17 2012 Kalev Lember <kalevlember@gmail.com> - 2.38.1-1
- Update to 2.38.1

* Mon Mar 26 2012 Kalev Lember <kalevlember@gmail.com> - 2.38.0-1
- Update to 2.38.0

* Sun Mar 11 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.37.90-3
- Added win64 support

* Tue Mar 06 2012 Kalev Lember <kalevlember@gmail.com> - 2.37.90-2
- Renamed the source package to mingw-libsoup (#800433)
- Use mingw macros without leading underscore

* Tue Feb 28 2012 Kalev Lember <kalevlember@gmail.com> - 2.37.90-1
- Update to 2.37.90
- Remove the .la files

* Mon Feb 27 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.37.5-2
- Rebuild against the mingw-w64 toolchain

* Tue Feb 07 2012 Kalev Lember <kalevlember@gmail.com> - 2.37.5-1
- Update to 2.37.5

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.36.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Oct 18 2011 Kalev Lember <kalevlember@gmail.com> - 2.36.1-1
- Update to 2.36.1

* Sun Oct 02 2011 Kalev Lember <kalevlember@gmail.com> - 2.36.0-1
- Update to 2.36.0
- Spec cleanup for recent rpmbuild

* Thu Jul 07 2011 Kalev Lember <kalevlember@gmail.com> - 2.34.1-2
- Rebuilt against win-iconv

* Wed Apr 27 2011 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.34.1-1
- Update to 2.34.1
- Build with --with-gnome
- Dropped the BR: mingw32-gnutls as support for TLS connections has
  moved to glib-networking

* Sun Apr 24 2011 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.34.0-1
- Update to 2.34.0

* Fri Apr 22 2011 Kalev Lember <kalev@smartlink.ee> - 2.32.0-3
- Rebuilt for pseudo-reloc version mismatch (#698827)

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.32.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Nov  7 2010 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.32.0-1
- Update to 2.32.0

* Fri Nov 20 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.28.1-1
- Update to 2.28.1

* Sat Sep 19 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.27.92-2
- Rebuild because of broken mingw32-gcc/mingw32-binutils
- Added a patch to workaround GNOME BZ #595176

* Thu Sep 10 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.27.92-1
- Update to 2.27.92
- Dropped the workaround for GNOME BZ #593845

* Tue Sep  1 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.27.91-1
- Update to 2.27.91

* Thu Aug 13 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.27.90-1
- Update to 2.27.90
- Automatically generate debuginfo subpackage
- Added BR: mingw32-gnutls for SSL support

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.27.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jun 10 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.27.1-1
- Update to 2.27.1

* Fri May 22 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.26.1-2
- Fixed license typo
- Use %%global instead of %%define
- Fixed mixed-use-of-spaces-and-tabs rpmlint warning

* Sat May  9 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.26.1-1
- Update to 2.26.1

* Fri Apr  3 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.26.0-2
- Added -static subpackage

* Fri Mar 20 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.26.0-1
- Update to 2.26.0

* Sat Feb 14 2009 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.25.5-1
- Initial release

